import Joi from "joi";
import mongoose from "mongoose";

const Users = mongoose.model("Users");

/**
 * Classe permettant la gestion de l'utilisateur connecté
 */
class Me {
    constructor(req) {
        this.req = req;
    }

    /**
     * Méthode permettant de modifier le profil d'un utilisateur
     * @return {Object}
     */
    async patchMe() {
        const { body, user } = this.req;

        const schema = Joi.object({
            isPublicCollection: Joi.boolean(),
        });

        const value = await schema.validateAsync(body);
        const update = await Users.findByIdAndUpdate(
            user._id,
            { $set: value },
            { new: true }
        );

        await new Promise((resolve, reject) => {
            this.req.login(update, (err) => {
                if (err) {
                    return reject(err);
                }

                return resolve(null);
            });
        });

        return update;
    }
}

export default Me;
